/*
polyprint.v1

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package polyprintapi

import (
	"encoding/json"
)

// checks if the CreatePrintOrderRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreatePrintOrderRequest{}

// CreatePrintOrderRequest struct for CreatePrintOrderRequest
type CreatePrintOrderRequest struct {
	DocumentId interface{} `json:"document_id"`
	PrintType interface{} `json:"print_type"`
	PersonalizationData CreatePrintOrderRequestPersonalizationData `json:"personalization_data"`
	ChannelId interface{} `json:"channel_id"`
	TransactionId interface{} `json:"transaction_id"`
	ProductionData CreatePrintOrderRequestProductionData `json:"production_data"`
	UserId interface{} `json:"user_id,omitempty"`
	CustomerExperienceId interface{} `json:"customer_experience_id,omitempty"`
}

// NewCreatePrintOrderRequest instantiates a new CreatePrintOrderRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreatePrintOrderRequest(documentId interface{}, printType interface{}, personalizationData CreatePrintOrderRequestPersonalizationData, channelId interface{}, transactionId interface{}, productionData CreatePrintOrderRequestProductionData) *CreatePrintOrderRequest {
	this := CreatePrintOrderRequest{}
	this.DocumentId = documentId
	this.PrintType = printType
	this.PersonalizationData = personalizationData
	this.ChannelId = channelId
	this.TransactionId = transactionId
	this.ProductionData = productionData
	return &this
}

// NewCreatePrintOrderRequestWithDefaults instantiates a new CreatePrintOrderRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreatePrintOrderRequestWithDefaults() *CreatePrintOrderRequest {
	this := CreatePrintOrderRequest{}
	return &this
}

// GetDocumentId returns the DocumentId field value
// If the value is explicit nil, the zero value for interface{} will be returned
func (o *CreatePrintOrderRequest) GetDocumentId() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}

	return o.DocumentId
}

// GetDocumentIdOk returns a tuple with the DocumentId field value
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *CreatePrintOrderRequest) GetDocumentIdOk() (*interface{}, bool) {
	if o == nil || IsNil(o.DocumentId) {
		return nil, false
	}
	return &o.DocumentId, true
}

// SetDocumentId sets field value
func (o *CreatePrintOrderRequest) SetDocumentId(v interface{}) {
	o.DocumentId = v
}

// GetPrintType returns the PrintType field value
// If the value is explicit nil, the zero value for interface{} will be returned
func (o *CreatePrintOrderRequest) GetPrintType() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}

	return o.PrintType
}

// GetPrintTypeOk returns a tuple with the PrintType field value
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *CreatePrintOrderRequest) GetPrintTypeOk() (*interface{}, bool) {
	if o == nil || IsNil(o.PrintType) {
		return nil, false
	}
	return &o.PrintType, true
}

// SetPrintType sets field value
func (o *CreatePrintOrderRequest) SetPrintType(v interface{}) {
	o.PrintType = v
}

// GetPersonalizationData returns the PersonalizationData field value
func (o *CreatePrintOrderRequest) GetPersonalizationData() CreatePrintOrderRequestPersonalizationData {
	if o == nil {
		var ret CreatePrintOrderRequestPersonalizationData
		return ret
	}

	return o.PersonalizationData
}

// GetPersonalizationDataOk returns a tuple with the PersonalizationData field value
// and a boolean to check if the value has been set.
func (o *CreatePrintOrderRequest) GetPersonalizationDataOk() (*CreatePrintOrderRequestPersonalizationData, bool) {
	if o == nil {
		return nil, false
	}
	return &o.PersonalizationData, true
}

// SetPersonalizationData sets field value
func (o *CreatePrintOrderRequest) SetPersonalizationData(v CreatePrintOrderRequestPersonalizationData) {
	o.PersonalizationData = v
}

// GetChannelId returns the ChannelId field value
// If the value is explicit nil, the zero value for interface{} will be returned
func (o *CreatePrintOrderRequest) GetChannelId() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *CreatePrintOrderRequest) GetChannelIdOk() (*interface{}, bool) {
	if o == nil || IsNil(o.ChannelId) {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *CreatePrintOrderRequest) SetChannelId(v interface{}) {
	o.ChannelId = v
}

// GetTransactionId returns the TransactionId field value
// If the value is explicit nil, the zero value for interface{} will be returned
func (o *CreatePrintOrderRequest) GetTransactionId() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}

	return o.TransactionId
}

// GetTransactionIdOk returns a tuple with the TransactionId field value
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *CreatePrintOrderRequest) GetTransactionIdOk() (*interface{}, bool) {
	if o == nil || IsNil(o.TransactionId) {
		return nil, false
	}
	return &o.TransactionId, true
}

// SetTransactionId sets field value
func (o *CreatePrintOrderRequest) SetTransactionId(v interface{}) {
	o.TransactionId = v
}

// GetProductionData returns the ProductionData field value
func (o *CreatePrintOrderRequest) GetProductionData() CreatePrintOrderRequestProductionData {
	if o == nil {
		var ret CreatePrintOrderRequestProductionData
		return ret
	}

	return o.ProductionData
}

// GetProductionDataOk returns a tuple with the ProductionData field value
// and a boolean to check if the value has been set.
func (o *CreatePrintOrderRequest) GetProductionDataOk() (*CreatePrintOrderRequestProductionData, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ProductionData, true
}

// SetProductionData sets field value
func (o *CreatePrintOrderRequest) SetProductionData(v CreatePrintOrderRequestProductionData) {
	o.ProductionData = v
}

// GetUserId returns the UserId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *CreatePrintOrderRequest) GetUserId() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.UserId
}

// GetUserIdOk returns a tuple with the UserId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *CreatePrintOrderRequest) GetUserIdOk() (*interface{}, bool) {
	if o == nil || IsNil(o.UserId) {
		return nil, false
	}
	return &o.UserId, true
}

// HasUserId returns a boolean if a field has been set.
func (o *CreatePrintOrderRequest) HasUserId() bool {
	if o != nil && IsNil(o.UserId) {
		return true
	}

	return false
}

// SetUserId gets a reference to the given interface{} and assigns it to the UserId field.
func (o *CreatePrintOrderRequest) SetUserId(v interface{}) {
	o.UserId = v
}

// GetCustomerExperienceId returns the CustomerExperienceId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *CreatePrintOrderRequest) GetCustomerExperienceId() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.CustomerExperienceId
}

// GetCustomerExperienceIdOk returns a tuple with the CustomerExperienceId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *CreatePrintOrderRequest) GetCustomerExperienceIdOk() (*interface{}, bool) {
	if o == nil || IsNil(o.CustomerExperienceId) {
		return nil, false
	}
	return &o.CustomerExperienceId, true
}

// HasCustomerExperienceId returns a boolean if a field has been set.
func (o *CreatePrintOrderRequest) HasCustomerExperienceId() bool {
	if o != nil && IsNil(o.CustomerExperienceId) {
		return true
	}

	return false
}

// SetCustomerExperienceId gets a reference to the given interface{} and assigns it to the CustomerExperienceId field.
func (o *CreatePrintOrderRequest) SetCustomerExperienceId(v interface{}) {
	o.CustomerExperienceId = v
}

func (o CreatePrintOrderRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreatePrintOrderRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.DocumentId != nil {
		toSerialize["document_id"] = o.DocumentId
	}
	if o.PrintType != nil {
		toSerialize["print_type"] = o.PrintType
	}
	toSerialize["personalization_data"] = o.PersonalizationData
	if o.ChannelId != nil {
		toSerialize["channel_id"] = o.ChannelId
	}
	if o.TransactionId != nil {
		toSerialize["transaction_id"] = o.TransactionId
	}
	toSerialize["production_data"] = o.ProductionData
	if o.UserId != nil {
		toSerialize["user_id"] = o.UserId
	}
	if o.CustomerExperienceId != nil {
		toSerialize["customer_experience_id"] = o.CustomerExperienceId
	}
	return toSerialize, nil
}

type NullableCreatePrintOrderRequest struct {
	value *CreatePrintOrderRequest
	isSet bool
}

func (v NullableCreatePrintOrderRequest) Get() *CreatePrintOrderRequest {
	return v.value
}

func (v *NullableCreatePrintOrderRequest) Set(val *CreatePrintOrderRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableCreatePrintOrderRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableCreatePrintOrderRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreatePrintOrderRequest(val *CreatePrintOrderRequest) *NullableCreatePrintOrderRequest {
	return &NullableCreatePrintOrderRequest{value: val, isSet: true}
}

func (v NullableCreatePrintOrderRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreatePrintOrderRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


